{ F4GLP_016 V3                     07/12/2014              BON
Ce programme utilise RSCOM.DLL
DLL disponible  l'adresse suivante : http://www.b-kainka.de/
La commande "Connexion" ouvre le port COM1 tel que :
 'COM1: baud=9600 parity=N data=8 stop=0' et active les pins  la demande du
 client.

La commande "Dconnexion" permet de refermer le port
}

unit Ucommande_RS232;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RTS_CheckBox1: TCheckBox;
    Image1_RS232: TImage;
    TXD_CheckBox1: TCheckBox;
    DTR_CheckBox1: TCheckBox;
    Label2: TLabel;
    PopupMenu1: TPopupMenu;
    proposde1: TMenuItem;
    Quiter1: TMenuItem;
    ListeCom: TComboBox;
    Label1: TLabel;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RTS_CheckBox1Click(Sender: TObject);
    procedure TXD_CheckBox1Click(Sender: TObject);
    procedure DTR_CheckBox1Click(Sender: TObject);
    procedure proposde1Click(Sender: TObject);
    procedure Quiter1Click(Sender: TObject);

    
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

function NumeroPort(Nomport:string):TStrings;

implementation

{$R *.DFM}

{---------------------------------------------------------------------------}
{ Cette fonction explore la base de registre  la recherche des ports srie }
{ disponibles de l'ordinateur.                                              }
{ avant: rien                                                               }
{ aprs: retour de la liste des ports srie sous forme de TSrings           }
{ source :                                                                  }
{ http://www.delphifr.com/codes/RECHERCHE-AUTOMATIQUE-PORT-SERIE_34072.aspx }
{---------------------------------------------------------------------------}
function NumeroPort(Nomport:string): TStrings;
var
  KeyHandle: HKEY;
  ErrCode, Index: Integer;
  ValueName, Data: string;
  ValueLen, DataLen, ValueType: DWORD;
  TmpPorts: TStringList;
begin
  ErrCode := RegOpenKeyEx(HKEY_LOCAL_MACHINE, 'HARDWARE\DEVICEMAP\SERIALCOMM',
                          0, KEY_READ, KeyHandle);

  if ErrCode <> ERROR_SUCCESS then
    raise Exception.Create('erreur d''ouverture');

  TmpPorts := TStringList.Create;
  Index := 0;
  repeat
    ValueLen := 256;
    DataLen := 256;
    SetLength(ValueName, ValueLen);
    SetLength(Data, DataLen);
    ErrCode := RegEnumValue(KeyHandle, Index, PChar(ValueName),
    {$IFDEF DELPHI_4_OR_HIGHER}
    Cardinal(ValueLen),
    {$ELSE}
    ValueLen,
    {$ENDIF}
    nil, @ValueType, PByte(PChar(Data)), @DataLen);

    if ErrCode = ERROR_SUCCESS then begin
     TmpPorts.Add('COM' + IntToStr(Index + 1));
     Inc(Index);
    end;
  until (ErrCode <> ERROR_SUCCESS) ;
  RegCloseKey(KeyHandle);
  Result := TmpPorts;
end;
{---------------------------------------------------------------------------}


//Importe les procdures et les fonctions de la DLL que l'on a besoin
function OPENCOM(OpenString:PChar):Integer; stdcall; external 'RSCOM.DLL';
procedure CLOSECOM(); stdcall; external 'RSCOM.DLL';
procedure RTS(d:WORD); stdcall; external 'RSCOM.DLL';
procedure TXD(d:WORD); stdcall; external 'RSCOM.DLL';
procedure DTR(d:WORD); stdcall; external 'RSCOM.DLL';

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListeCom.Items := NumeroPort('');
end;

//Gestion du bouton "Connexion"
procedure TForm1.Button1Click(Sender: TObject);
begin
//C'est pas beau mais a fonctionne !...
if ListeCom.Text = 'COM1' then OpenCom('COM1: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM1
if ListeCom.Text = 'COM2' then OpenCom('COM2: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM2
if ListeCom.Text = 'COM3' then OpenCom('COM3: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM3
if ListeCom.Text = 'COM4' then OpenCom('COM4: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM4
if ListeCom.Text = 'COM5' then OpenCom('COM5: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM5
if ListeCom.Text = 'COM6' then OpenCom('COM6: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM6
if ListeCom.Text = 'COM7' then OpenCom('COM7: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM7
if ListeCom.Text = 'COM8' then OpenCom('COM8: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM8
if ListeCom.Text = 'COM9' then OpenCom('COM9: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM9
if ListeCom.Text = 'COM10' then OpenCom('COM10: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM10
if ListeCom.Text = 'COM11' then OpenCom('COM11: baud=9600 parity=N data=8 stop=0'); //Ouvre et paramtre la connexion sur COM11
if ListeCom.Text = 'COM12' then OpenCom('COM12: baud=9600 parity=N data=8 stop=0') //Ouvre et paramtre la connexion sur COM12
else Edit1.Text:='Erreur';
Edit1.Text:= ListeCom.Text;
end;


procedure TForm1.DTR_CheckBox1Click(Sender: TObject);
begin
if  DTR_CheckBox1.Checked=True
        then  DTR(1) //Envoi la valeur "1" vers la sortie pour que relais commute (PTT)
        else  DTR(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
end;

procedure TForm1.RTS_CheckBox1Click(Sender: TObject);
begin
if  RTS_CheckBox1.Checked=True
        then  RTS(1) //Envoi la valeur "1" vers la sortie pour que relais commute (PTT)
        else  RTS(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
end;

procedure TForm1.TXD_CheckBox1Click(Sender: TObject);
begin
if  TXD_CheckBox1.Checked=True
        then  TXD(1) //Envoi la valeur "1" vers la sortie pour que relais commute (PTT)
        else  TXD(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
end;


//Gestion du bouton "Dconnexion"
procedure TForm1.Button2Click(Sender: TObject);
begin
DTR(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
RTS(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
TXD(0); //Envoi la valeur "0" vers la sortie pour que relais soit non passant
RTS_CheckBox1.Checked:=False;   //On dcoche la case.
TXD_CheckBox1.Checked:=False;   //On dcoche la case.
DTR_CheckBox1.Checked:=False;   //On dcoche la case.
CloseCOM; //Libre le port
Edit1.Text:='';
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
CloseCOM; //Libre le port
end;

//Procdure du popup click droit " propos de..."
procedure TForm1.proposde1Click(Sender: TObject);
begin
Application.MessageBox('V3 - Un programme de F4GLP    http://f4glp.free.fr/ ',' propos de...', MB_OK+MB_ICONINFORMATION);
Application.MessageBox('Ce programme utilise RSCOM.DLL    http://www.b-kainka.de/ ',' propos de...', MB_OK+MB_ICONINFORMATION);
end;

//Procdure du popup click droit "Quiter..."
procedure TForm1.Quiter1Click(Sender: TObject);
begin
CloseCOM; //Libre le port
close;
end;


end.
